## atlas-cpp 0.6.4

=== protocol/spec/Makefile ===
CODE=gen_html.py ParseDef.py def2xml.py gen_atlas.py
DEFS=root.atlas entity.atlas operation.atlas type.atlas interface.atlas
OLD_DEFS=root.def entity.def operation.def type.def interface.def map.def agrilan_map.def
INPUT=root_in.html entity_in.html operation_in.html type_in.html \
	interface_in.html
HTML_OUTPUT=root.html entity.html operation.html type.html interface.html \
	map.html agrilan_map.html

all: atlas.atlas atlas.xml ${HTML_OUTPUT}

atlas.atlas: ${CODE} ${INPUT} ${DEFS}
	python gen_atlas.py

atlas.xml: ${CODE} ${INPUT} ${OLD_DEFS}
	python def2xml.py

${HTML_OUTPUT}: atlas.atlas ${CODE} ${INPUT} ${DEFS}
	python gen_html.py

=== protocol/spec/maps/Makefile ===
all: semantic_maps.pdf semantic_maps.html

semantic_maps.pdf: semantic_maps.toc semantic_maps.aux
	pdflatex semantic_maps.tex

semantic_maps.toc semantic_maps.aux: semantic_maps.tex atlas.sty
	pdflatex semantic_maps.tex

semantic_maps.html: semantic_maps.tex atlas.sty
	latex2html semantic_maps.tex

## atlas-cpp 0.6.2

=== debian/changelog ===
atlas-cpp (0.6.2-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update symbol files (cherry picked from packaging VCS) (Closes: #718711)

 -- Tobias Frost <tobi@debian.org>  Sun, 10 Aug 2014 13:46:43 +0000

atlas-cpp (0.6.2-4) unstable; urgency=low

  * debian/control: updated Standards-Version to 3.9.4 (updated VCS-* fields)
  * debian/libatlas-cpp-0.6-1.symbols: fixed for GCC 4.8 (closes: #701245)
  * debian/control, debian/rules: pulled in doxygen as build-dep only for
    Architecture:all targets.

 -- Stephen M. Webb <stephen.webb@bregmasoft.ca>  Fri, 21 Jun 2013 14:17:11 -0400

atlas-cpp (0.6.2-3) unstable; urgency=low

  * debian/libatlas-cpp-0.6-1.symbols: added more optional symbols
    - fixes a FTBFS with GCC 4.7 (closes: #671948)

 -- Stephen M. Webb <stephen.webb@bregmasoft.ca>  Wed, 30 May 2012 09:46:32 -0400

atlas-cpp (0.6.2-2) unstable; urgency=low

  * 0003-add-protocol-xml-file.patch: add the protocol spec
    - missing spec causes a FTBFS during check phase (closes: #664549)
  * debian/libatlas-cpp-0.6-1.symbols: adjusted for ia64

 -- Stephen M. Webb <stephen.webb@bregmasoft.ca>  Tue, 10 Apr 2012 14:39:02 -0400

atlas-cpp (0.6.2-1) unstable; urgency=low

  * new upstream release
  * new maintainer (Debian games team) (closes: #653950)
  * converted to 3.0 (quilt) source format
  * updated Standards-Version to 3.9.3
  * debian/control: added Vcs- fields
  * regenerate the autotools at build time to fix rpath problems
  * debian/libatlas-cpp-0.6-1.symbols: added
  * added .doc-base files for the -doc package
  * removed unneeded patches
  * added a manpage for the atlas_convert tool
  * added lintian override for multiple DSOs in package
  * added zlib and libbz build dependencies
  * debian/rules: convert to use dh build sequencer
  * use xz compression for packaging
  * moved to debhelper compat level 9, including multi-arch
  * debian/copyright: convert to DEP-5 format

 -- Stephen M. Webb <stephen.webb@bregmasoft.ca>  Sat, 03 Mar 2012 10:39:45 -0500

atlas-cpp (0.6.1-4) unstable; urgency=low

  * debian/libatlas-cpp-0.6-dev.install: Don't install *.la files.
  * debian/control: Updated Standards-Version to 3.8.3.

 -- Michael Koch <konqueror@gmx.de>  Thu, 27 Aug 2009 08:46:37 +0200

atlas-cpp (0.6.1-3) unstable; urgency=low

  * debian/patches/atlas-cpp-gcc44.patch: Added to fix includes
    for GCC 4.4 (Closes: #505123)
  * debian/copyright: Add real copyright statement.
  * debian/watch: Use SourceForge redirector.
  * debian/control: Move libatlas-cpp--dbg to debug section.
  * debian/control: Add Depends: ${misc:Depends} to all packages.
  * debian/control: libatlas-cpp-doc: Fix repeated word 'API'.
  * debian/control: Add Homepage field.
  * debian/control: Updated Standards-Version to 3.8.2.

 -- Michael Koch <konqueror@gmx.de>  Tue, 21 Jul 2009 11:24:40 +0200

atlas-cpp (0.6.1-2) unstable; urgency=low

  * Fix includes for GCC 4.3. Closes: #455323.
  * Updated Standards-Version to 3.7.3.
  * Updated debhelper level to 5.

 -- Michael Koch <konqueror@gmx.de>  Tue, 11 Dec 2007 07:37:45 +0100

atlas-cpp (0.6.1-1) unstable; urgency=low

  * New upstream release
    - Removed debian/patches/atlas-cpp-gcc43.patch. Obsolete.

 -- Michael Koch <konqueror@gmx.de>  Sun, 25 Nov 2007 00:04:29 +0100

atlas-cpp (0.6.0-4) unstable; urgency=low

  * Move *.la files to -dev package. Closes: #452325.

 -- Michael Koch <konqueror@gmx.de>  Fri, 23 Nov 2007 20:34:34 +0100

atlas-cpp (0.6.0-3) unstable; urgency=low

  * Ported debian/rules to CDBS.
  * Added patch to make the package compile with GCC 4.3. Closes: #417110.
  * Replace obsolete ${Source-Version} in debian/control.

 -- Michael Koch <konqueror@gmx.de>  Thu, 28 Jun 2007 12:48:51 -0100

atlas-cpp (0.6.0-2) unstable; urgency=low

  * Upload to unstable.
  * Fix changelog to shut up lintian.

 -- Michael Koch <konqueror@gmx.de>  Mon, 04 Jun 2007 21:08:08 +0200

atlas-cpp (0.6.0-1) experimental; urgency=low

  * Upload to experimental.
  * New upstream release.
    - Changed sonames.
  * Fixed way to create debug info package.
  * Removed extra Build-Depends-Indep on doxygen.
  * Updated Standards-Version to 3.7.2.

 -- Michael Koch <konqueror@gmx.de>  Wed, 14 Feb 2007 12:07:04 +0000

atlas-cpp (0.5.98-3) unstable; urgency=low

  * Renamed the binary packages again to use the correct name scheme for the
    C++ ABI transition and add the correct conflicts (Closes: #341673).

 -- Michael Koch <konqueror@gmx.de>  Mon, 19 Dec 2005 22:43:03 +0000

atlas-cpp (0.5.98-2) unstable; urgency=low

  * Did the new C++ ABI transition and renamed some packages (Closes: #339151).

 -- Michael Koch <konqueror@gmx.de>  Sat, 26 Nov 2005 15:38:55 +0000

atlas-cpp (0.5.98-1) unstable; urgency=low

  * New upstream release

 -- Michael Koch <konqueror@gmx.de>  Sun,  2 Oct 2005 11:41:44 +0000

atlas-cpp (0.5.97-1) unstable; urgency=low

  * New upstream release

 -- Michael Koch <konqueror@gmx.de>  Sat, 17 Sep 2005 11:27:10 +0000

atlas-cpp (0.5.96-3) unstable; urgency=low

  * Fixed Suggest for libatlas-cpp-doc on libatlas-cpp-0.6-0-dev
  * Added watch file
  * Upload sponsored by Petter Reinholdtsen

 -- Michael Koch <konqueror@gmx.de>  Fri,  9 Sep 2005 05:59:51 +0000

atlas-cpp (0.5.96-2) unstable; urgency=low

  * Include the needed files in libatlas-cpp-0.6-dev package

 -- Michael Koch <konqueror@gmx.de>  Mon,  5 Sep 2005 06:12:03 +0000

atlas-cpp (0.5.96-1) unstable; urgency=low

  * New upstream release
  * Renamed binary packages to match soname
  * debian/rules: Adjusted for new soname
  * Updated address of FSF in debian/copyright
  * Updated Standards-Version to 3.6.2

 -- Michael Koch <konqueror@gmx.de>  Thu,  1 Sep 2005 04:33:44 +0000

atlas-cpp (0.4.94-2) unstable; urgency=low

  * debian/copyright: Added better copyright notice and fixed download URL

 -- Michael Koch <konqueror@gmx.de>  Sun, 25 Jul 2004 18:14:22 +0200

atlas-cpp (0.4.94-1) unstable; urgency=low

  * New upstream release


=== debian/control ===
Source: atlas-cpp
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen M. Webb <stephen.webb@bregmasoft.ca>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libbz2-dev,
               zlib1g-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.4
Homepage: http://www.worldforge.org/
Vcs-Git: git://anonscm.debian.org/pkg-games/atlas-cpp.git
Vcs-Browser: http://anonscm.debian.org/git/pkg-games/atlas-cpp.git

Package: libatlas-cpp-0.6-1
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: World Forge wire protocol library - runtime libs
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This is the runtime component of the Atlas-C++ toolkit.

Package: libatlas-cpp-0.6-1-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Pre-Depends: dpkg (>= 1.15.6~)
Depends: libatlas-cpp-0.6-1 (= ${binary:Version}), ${misc:Depends}
Description: World Forge wire protocol library - debugging libs
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This is the debugging component of the Atlas-C++ toolkit.

Package: libatlas-cpp-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${misc:Depends}
Suggests: libatlas-cpp-0.6-dev (>= ${source:Version})
Description: World Forge wire protocol library - documentation
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This is the API documentation of the Atlas-C++ toolkit.

Package: libatlas-cpp-0.6-dev
Architecture: any
Section: libdevel
Pre-Depends: dpkg (>= 1.15.6~)
Depends: libatlas-cpp-0.6-1 (= ${binary:Version}),
         pkg-config,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libatlas-cpp-0.6-1-dbg (= ${binary:Version}),
          libatlas-cpp-doc (>= ${source:Version})
Conflicts: libatlas-cpp-0.6-0-dev
Replaces: libatlas-cpp-0.6-0-dev
Description: World Forge wire protocol library - developer files
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This contains the development files needed to compile and link programs
 with the Atlas-C++ toolkit.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autoreconf

override_dh_install:
	dh_install --fail-missing -X.la -X.a

override_dh_auto_build-indep:
	$(MAKE) docs

override_dh_auto_test-indep:

override_dh_auto_clean:
	rm -rf doc/*
	dh_auto_clean

override_dh_strip:
	set -e; \
	for pkg in $(patsubst %-dbg,%,$(filter %-dbg,$(shell dh_listpackages))); do \
		dh_strip -p$${pkg} --dbg-package=$${pkg}-dbg; \
	done
	dh_strip -s --remaining-packages

override_dh_builddeb:
	dh_builddeb -- -Zxz

=== debian/watch ===
version=3
http://sf.net/worldforge/Atlas-C\+\+-([\d+\.]+|\d+)\.tar\.bz2 debian

## atlas-cpp 0.6.3

=== debian/changelog ===
atlas-cpp (0.6.3-2ubuntu1) xenial; urgency=medium

  * Mark additional symbols as optional, missing when built with -O3.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 10 Feb 2016 16:57:49 +0100

atlas-cpp (0.6.3-2) unstable; urgency=medium

  * Fix symbols file for multiple architectures (Closes: #800927)
  * Declare Breaks+Replaces (Closes: #800925)
    - Between old -dev and new -tools binary packages

 -- Olek Wojnar <olek-dev@wojnar.org>  Sun, 04 Oct 2015 21:14:25 -0500

atlas-cpp (0.6.3-1) unstable; urgency=medium

  * New upstream version
  * Incorporate and acknowledge NMU, thanks Tobias Frost
  * Add myself as new uploader
    - Remove Stephen Webb per his request
    - Thanks for all the contributions, Stephen!
  * Update lintian overrides
  * d/copyright: update information
  * d/control: remove pre-dependency on dpkg
  * d/rules: enable parallel build
  * d/rules: remove builddeb override since xz is now default
  * d/watch: update file extensions
  * d/control: tweaks and update standards to 3.9.6 (no changes)
  * Bump SO-name
  * Split tools package from dev package for Multi-Arch sanity

 -- Olek Wojnar <olek-dev@wojnar.org>  Sun, 27 Sep 2015 01:19:00 -0500

atlas-cpp (0.6.2-5) unstable; urgency=medium

  * Team upload.
  * Rename library package for g++-5 ABI transition, and update symbols
    files. Based on Ubuntu patch by Steve Langasek. (Closes: #777784,
    #790982)

 -- Simon McVittie <smcv@debian.org>  Tue, 18 Aug 2015 21:21:57 +0100

=== debian/control ===
Source: atlas-cpp
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Olek Wojnar <olek-dev@wojnar.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libbz2-dev,
               zlib1g-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Homepage: http://www.worldforge.org/
Vcs-Git: git://anonscm.debian.org/pkg-games/atlas-cpp.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/atlas-cpp.git

Package: libatlas-cpp-0.6-2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: World Forge wire protocol library - runtime libs
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This is the runtime component of the Atlas-C++ toolkit.

Package: libatlas-cpp-0.6-2-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: libatlas-cpp-0.6-2 (= ${binary:Version}), ${misc:Depends}
Description: World Forge wire protocol library - debugging libs
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This is the debugging component of the Atlas-C++ toolkit.

Package: libatlas-cpp-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libatlas-cpp-0.6-dev (>= ${source:Version})
Description: World Forge wire protocol library - documentation
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This is the API documentation of the Atlas-C++ toolkit.

Package: libatlas-cpp-0.6-tools
Architecture: any
Multi-Arch: foreign
Section: games
Depends: libatlas-cpp-0.6-2 (= ${binary:Version}),
         pkg-config,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libatlas-cpp-0.6-2-dbg (= ${binary:Version}),
          libatlas-cpp-0.6-dev (= ${binary:Version}),
          libatlas-cpp-doc (>= ${source:Version})
Breaks: libatlas-cpp-0.6-dev (<< 0.6.3)
Replaces: libatlas-cpp-0.6-dev (<< 0.6.3)
Description: World Forge wire protocol library - tools
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This contains the tool that converts Atlas data files between formats.

Package: libatlas-cpp-0.6-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libatlas-cpp-0.6-2 (= ${binary:Version}),
         libatlas-cpp-0.6-tools (= ${binary:Version}),
         pkg-config,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libatlas-cpp-0.6-2-dbg (= ${binary:Version}),
          libatlas-cpp-doc (>= ${source:Version})
Conflicts: libatlas-cpp-0.6-0-dev
Replaces: libatlas-cpp-0.6-0-dev
Description: World Forge wire protocol library - developer files
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This contains the development files needed to compile and link programs
 with the Atlas-C++ toolkit.

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 %:
-	dh $@ --with autoreconf
+	dh $@ --parallel --with autoreconf
 
 override_dh_install:
 	dh_install --fail-missing -X.la -X.a
@@ -21,7 +21,3 @@
 		dh_strip -p$${pkg} --dbg-package=$${pkg}-dbg; \
 	done
 	dh_strip -s --remaining-packages
-
-override_dh_builddeb:
-	dh_builddeb -- -Zxz
-

=== debian/watch ===
version=3
http://sf.net/worldforge/Atlas-C\+\+-([\d+\.]+|\d+)\.(?:tar\.(?:gz|bz2|xz)) debian uupdate

## atlas-cpp 0.6.4

=== debian/changelog ===
atlas-cpp (0.6.4-3) unstable; urgency=high

  * Update debhelper compatibility to 13 (no changes)
  * Update standards to 4.5.0 (no changes)
  * Remove d/symbols due to continued instability (Closes: #957017, #893681)

 -- Olek Wojnar <olek@debian.org>  Fri, 31 Jul 2020 21:07:41 -0400

atlas-cpp (0.6.4-2) unstable; urgency=medium

  * Update d/control
    - New uploader email and URLs
    - Standards to 4.2.1 (no changes)
    - Add Rules-Requires-Root declaration
    - Remove dpkg-dev versioned build-depend, higher version in oldoldstable
  * Update d/copyright: refresh Debian info and emails
  * Update d/compat: 11 (no changes)
  * Add d/upstream/metadata: for DEP 12 compliance
  * Update d/rules: migration complete, remove dbgsym-migration flag
  * Update d/symbols for GCC-8

 -- Olek Wojnar <olekw.dev@gmail.com>  Sun, 14 Oct 2018 15:04:54 -0400

atlas-cpp (0.6.4-1) experimental; urgency=medium

  * New Upstream version
   - Update d/copyright
   - Bump SO-name and update:
     + d/control
     + d/package.install
     + d/package.lintian-overrides
     + d/package.symbols

  [ Tobias Frost ]
  * Upload to experimental.

 -- Olek Wojnar <olek-dev@wojnar.org>  Sun, 31 Dec 2017 19:45:39 -0500

atlas-cpp (0.6.3-4) unstable; urgency=medium

  * Update d/symbols for GCC 7 (Closes: #853323)
  * Update standards to 4.1.3
    - d/control: document new standards version
    - d/copyright: use https in Format field
    - d/watch: use https
  * Update dh compat to 10
    - Update d/rules
    - Remove unnecessary ldconfig trigger
  * Update d/copyright for ./debian directory

 -- Olek Wojnar <olek-dev@wojnar.org>  Sun, 15 Oct 2017 13:30:49 -0500

atlas-cpp (0.6.3-3) unstable; urgency=medium

  * Integrate symbol fix from Ubuntu, thanks Matthias Klose
  * Fix symbols for GCC6 (Closes: #811982)
  * Update d/control
    - Standards-Version to 3.9.8 (no changes)
    - Update Vcs lines for secure URIs
  * Enable all hardening options
  * Update d/copyright
  * Add ldconfig trigger
  * Convert to automatic debug package

 -- Olek Wojnar <olek-dev@wojnar.org>  Sun, 03 Jul 2016 14:11:04 -0400

=== debian/control ===
Source: atlas-cpp
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Olek Wojnar <olek@debian.org>,
           Debian Games Team <team+pkg-games@tracker.debian.org>,
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libbz2-dev,
               zlib1g-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://www.worldforge.org/
Vcs-Git: https://salsa.debian.org/games-team/atlas-cpp.git
Vcs-Browser: https://salsa.debian.org/games-team/atlas-cpp

Package: libatlas-cpp-0.6-3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: World Forge wire protocol library - runtime libs
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This is the runtime component of the Atlas-C++ toolkit.

Package: libatlas-cpp-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libatlas-cpp-0.6-dev (>= ${source:Version})
Description: World Forge wire protocol library - documentation
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This is the API documentation of the Atlas-C++ toolkit.

Package: libatlas-cpp-0.6-tools
Architecture: any
Multi-Arch: foreign
Section: games
Depends: libatlas-cpp-0.6-3 (= ${binary:Version}),
         pkg-config,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libatlas-cpp-0.6-dev (= ${binary:Version}),
          libatlas-cpp-doc (>= ${source:Version})
Breaks: libatlas-cpp-0.6-dev (<< 0.6.3)
Replaces: libatlas-cpp-0.6-dev (<< 0.6.3)
Description: World Forge wire protocol library - tools
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This contains the tool that converts Atlas data files between formats.

Package: libatlas-cpp-0.6-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libatlas-cpp-0.6-3 (= ${binary:Version}),
         libatlas-cpp-0.6-tools (= ${binary:Version}),
         pkg-config,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libatlas-cpp-doc (>= ${source:Version})
Conflicts: libatlas-cpp-0.6-0-dev
Replaces: libatlas-cpp-0.6-0-dev
Description: World Forge wire protocol library - developer files
 This library implements the Atlas protocol, for use in client-server
 game applications.  It can be used in either clients or servers.
 .
 This contains the development files needed to compile and link programs
 with the Atlas-C++ toolkit.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_missing:
	dh_missing -X.la -X.a

override_dh_auto_build-indep:
	$(MAKE) docs

override_dh_auto_test-indep:

override_dh_auto_clean:
	rm -rf doc/*
	dh_auto_clean

=== debian/watch ===
version=4
https://sf.net/worldforge/Atlas-C\+\+-([\d+\.]+|\d+)\.(?:tar\.(?:gz|bz2|xz)) debian uupdate

## atlas-cpp 1500937782.9e555df

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(Atlas-C++)
set(CMAKE_CXX_STANDARD 14)
include(GNUInstallDirs)

# Version setup

set(ATLAS_VERSION_MAJOR 0)
set(ATLAS_VERSION_MINOR 7)
set(ATLAS_VERSION_PATCH 0)

set(VERSION ${ATLAS_VERSION_MAJOR}.${ATLAS_VERSION_MINOR}.${ATLAS_VERSION_PATCH})
set(SUFFIX -${ATLAS_VERSION_MAJOR}.${ATLAS_VERSION_MINOR})

set(ATLAS_ABI_CURRENT 0)
set(ATLAS_ABI_REVISION 0)
set(ATLAS_ABI_AGE 0)
math(EXPR ATLAS_SOVERSION ${ATLAS_ABI_CURRENT}-${ATLAS_ABI_AGE})
set(ATLAS_ABI_VERSION ${ATLAS_SOVERSION}.${ATLAS_ABI_AGE}.${ATLAS_ABI_REVISION})

# Set compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

include_directories("${PROJECT_SOURCE_DIR}")

# Meta data

set(DESCRIPTION "Networking protocol for the Worldforge system.")

# Define source files for libraries

set(CODECS_SOURCE_FILES
        Atlas/Codecs/Bach.cpp
        Atlas/Codecs/Packed.cpp
        Atlas/Codecs/XML.cpp)

set(CODECS_HEADER_FILES
        Atlas/Codecs/Bach.h
        Atlas/Codecs/Packed.h
        Atlas/Codecs/Utility.h
        Atlas/Codecs/XML.h)

set(OBJECTS_SOURCE_FILES
        Atlas/Objects/Anonymous.cpp
        Atlas/Objects/BaseObject.cpp
        Atlas/Objects/Decoder.cpp
        Atlas/Objects/Dispatcher.cpp
        Atlas/Objects/Encoder.cpp
        Atlas/Objects/Generic.cpp
        Atlas/Objects/loadDefaults.cpp
        Atlas/Objects/objectFactory.cpp
        Atlas/Objects/Root.cpp
        Atlas/Objects/RootEntity.cpp
        Atlas/Objects/RootEntityChildren.cpp
        Atlas/Objects/RootOperation.cpp
        Atlas/Objects/RootOperationChildren1.cpp
        Atlas/Objects/RootOperationChildren2.cpp
        Atlas/Objects/RootOperationChildren3.cpp
        Atlas/Objects/RootOperationChildren4.cpp
        Atlas/Objects/RootOperationChildren5.cpp
        Atlas/Objects/SmartPtr.cpp)

set(OBJECTS_HEADER_FILES
        Atlas/Objects/Anonymous.h
        Atlas/Objects/BaseObject.h
        Atlas/Objects/Decoder.h
        Atlas/Objects/Dispatcher.h
        Atlas/Objects/Encoder.h
        Atlas/Objects/Entity.h
        Atlas/Objects/Generic.h
        Atlas/Objects/loadDefaults.h
        Atlas/Objects/objectFactory.h
        Atlas/Objects/ObjectsFwd.h
        Atlas/Objects/Operation.h
        Atlas/Objects/Root.h
        Atlas/Objects/RootEntity.h
        Atlas/Objects/RootOperation.h
        Atlas/Objects/SmartPtr.h)

set(FILTERS_SOURCE_FILES
        Atlas/Filters/Bzip2.cpp
        Atlas/Filters/Gzip.cpp)

set(FILTERS_HEADER_FILES
        Atlas/Filters/Bzip2.h
        Atlas/Filters/Gzip.h)

set(FUNKY_SOURCE_FILES
        Atlas/Funky/FEncoder.cpp)

set(FUNKY_HEADER_FILES
        Atlas/Funky/FEncoder.h)

set(MESSAGE_SOURCE_FILES
        Atlas/Message/DecoderBase.cpp
        Atlas/Message/Element.cpp
        Atlas/Message/MEncoder.cpp
        Atlas/Message/QueuedDecoder.cpp)

set(MESSAGE_HEADER_FILES
        Atlas/Message/DecoderBase.h
        Atlas/Message/Element.h
        Atlas/Message/MEncoder.h
        Atlas/Message/QueuedDecoder.h)

set(NET_SOURCE_FILES
        Atlas/Net/Loopback.cpp
        Atlas/Net/Stream.cpp)

set(NET_HEADER_FILES
        Atlas/Net/Loopback.h
        Atlas/Net/Stream.h)

set(SOURCE_FILES
        Atlas/Bridge.cpp
        Atlas/Codec.cpp
        Atlas/Codec_impl.h
        Atlas/EncoderBase.cpp
        Atlas/Exception.cpp
        Atlas/Filter.cpp
        Atlas/float.cpp
        Atlas/Formatter.cpp
        Atlas/MultiLineListFormatter.cpp
        Atlas/Negotiate.cpp
        Atlas/PresentationBridge.cpp)

set(HEADER_FILES
        Atlas/Bridge.h
        Atlas/Codec.h
        Atlas/Debug.h
        Atlas/EncoderBase.h
        Atlas/Exception.h
        Atlas/Filter.h
        Atlas/float.h
        Atlas/Formatter.h
        Atlas/MultiLineListFormatter.h
        Atlas/Negotiate.h
        Atlas/PresentationBridge.h
        Atlas/Task.h
        Atlas/Version.h)

include(FindPythonInterp)

if (PYTHONINTERP_FOUND)

    set(PY_SOURCES
            Atlas/Objects/gen_cpp.py
            Atlas/Objects/common.py
            Atlas/Objects/AttributeInfo.py
            Atlas/Objects/GenerateObjectFactory.py
            Atlas/Objects/GenerateDecoder.py
            Atlas/Objects/GenerateDispatcher.py
            Atlas/Objects/GenerateForward.py
            protocol/spec/atlas.xml)


    add_custom_target(GenerateAtlasObjects
            COMMAND ${CMAKE_COMMAND} -E echo_append "Generating Atlas Object sources."
            COMMAND ${PYTHON_EXECUTABLE} gen_cpp.py
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/Atlas/Objects
            DEPENDS ${PY_SOURCES}
            VERBATIM
    )

endif (PYTHONINTERP_FOUND)

# This macro defines a library
macro(wf_add_library _LIB_NAME _SOURCE_FILES_VAR _HEADER_FILES_VAR)

    add_library(${_LIB_NAME} SHARED ${${_SOURCE_FILES_VAR}})
    add_library(${_LIB_NAME}_STATIC STATIC ${${_SOURCE_FILES_VAR}})
    set_target_properties(${_LIB_NAME} PROPERTIES
            VERSION ${ATLAS_ABI_VERSION}
            SOVERSION ${ATLAS_SOVERSION}
            )

    install(TARGETS ${_LIB_NAME}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

    foreach (file ${${_HEADER_FILES_VAR}})
        get_filename_component(dir ${file} DIRECTORY)
        install(FILES ${file} DESTINATION include/${PROJECT_NAME}${SUFFIX}/${dir})
    endforeach ()

    set(PKG_CONFIG_LIBS "-l${_LIB_NAME} ${PKG_CONFIG_LIBS}")

endmacro()


wf_add_library(Atlas${SUFFIX} SOURCE_FILES HEADER_FILES)

wf_add_library(AtlasCodecs${SUFFIX} CODECS_SOURCE_FILES CODECS_HEADER_FILES)
target_link_libraries(AtlasCodecs${SUFFIX} Atlas${SUFFIX})

wf_add_library(AtlasNet${SUFFIX} NET_SOURCE_FILES NET_HEADER_FILES)
target_link_libraries(AtlasNet${SUFFIX} Atlas${SUFFIX} AtlasCodecs${SUFFIX})

wf_add_library(AtlasMessage${SUFFIX} MESSAGE_SOURCE_FILES MESSAGE_HEADER_FILES)
target_link_libraries(AtlasMessage${SUFFIX} Atlas${SUFFIX})

wf_add_library(AtlasObjects${SUFFIX} OBJECTS_SOURCE_FILES OBJECTS_HEADER_FILES)
target_link_libraries(AtlasObjects${SUFFIX} AtlasMessage${SUFFIX} AtlasCodecs${SUFFIX})
add_dependencies(AtlasObjects${SUFFIX} GenerateAtlasObjects)

wf_add_library(AtlasFilters${SUFFIX} FILTERS_SOURCE_FILES FILTERS_HEADER_FILES)
target_link_libraries(AtlasFilters${SUFFIX} Atlas${SUFFIX})

# The "atlas_convert" tool
add_executable(atlas_convert tools/atlas_convert.cpp)
target_link_libraries(atlas_convert AtlasCodecs${SUFFIX} AtlasMessage${SUFFIX} Atlas${SUFFIX})
install(TARGETS atlas_convert
        DESTINATION ${CMAKE_INSTALL_BINDIR})

# pkg-config files
configure_file(atlascpp.pc.in atlascpp${SUFFIX}.pc @ONLY)
install(FILES ${PROJECT_BINARY_DIR}/atlascpp${SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# man files
install(FILES man/man1/atlas_convert.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

# RPM spec files
configure_file(atlas-cpp.spec.in atlas-cpp.spec @ONLY)
configure_file(mingw32-atlas-cpp.spec.in mingw32-atlas-cpp.spec @ONLY)


# Check for libraries

find_package(BZip2)
if (BZIP2_FOUND)
    include_directories(${BZIP2_INCLUDE_DIRS})
    target_link_libraries(AtlasFilters${SUFFIX} ${BZIP2_LIBRARIES})
    add_definitions(-DHAVE_BZLIB_H -DHAVE_LIBBZ2)
endif (BZIP2_FOUND)

find_package(ZLIB)
if (ZLIB_FOUND)
    include_directories(${ZLIB_INCLUDE_DIRS})
    target_link_libraries(AtlasFilters${SUFFIX} ${ZLIB_LIBRARIES})
    add_definitions(-DHAVE_ZLIB_H -DHAVE_LIBZ)
endif (ZLIB_FOUND)

# Add test
enable_testing()

# Add a "check" target, which builds and runs the tests.
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} -E Benchmark)

# Add a "benchmark" target, which builds and runs the benchmarks.
add_custom_target(benchmark COMMAND ${CMAKE_CTEST_COMMAND} -R Benchmark)

#Macro for adding a test. The test name will be extracted from the name of the first submitted file.
#Additional files can be submitted as varargs.
macro(wf_add_test TEST_FILE)

    get_filename_component(TEST_NAME ${TEST_FILE} NAME_WE)

    add_executable(${TEST_NAME} EXCLUDE_FROM_ALL ${TEST_FILE} ${ARGN})
    target_link_libraries(${TEST_NAME} AtlasObjects${SUFFIX}_STATIC AtlasFilters${SUFFIX}_STATIC AtlasCodecs${SUFFIX}_STATIC AtlasMessage${SUFFIX}_STATIC Atlas${SUFFIX}_STATIC)
    add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME})

    add_dependencies(check ${TEST_NAME})
endmacro()

macro(wf_add_benchmark TEST_FILE)

    get_filename_component(TEST_NAME ${TEST_FILE} NAME_WE)

    add_executable(${TEST_NAME} EXCLUDE_FROM_ALL ${TEST_FILE} ${ARGN})
    target_link_libraries(${TEST_NAME} AtlasObjects${SUFFIX}_STATIC AtlasFilters${SUFFIX}_STATIC AtlasCodecs${SUFFIX}_STATIC AtlasMessage${SUFFIX}_STATIC Atlas${SUFFIX}_STATIC)
    add_test(NAME ${TEST_NAME}Benchmark COMMAND ${TEST_NAME})

    add_dependencies(benchmark ${TEST_NAME})
endmacro()

wf_add_test(tests/Codecs/codecs.cpp)
wf_add_test(tests/Objects/custom_ops.cpp)
wf_add_test(tests/Objects/objects1.cpp)
wf_add_test(tests/Objects/objects2.cpp)
wf_add_test(tests/Objects/encoder1.cpp)
wf_add_test(tests/Objects/decoder1.cpp)
wf_add_test(tests/Objects/objects_fwd.cpp)
wf_add_test(tests/Objects/attributes.cpp)
wf_add_test(tests/Objects/flags.cpp)
add_definitions(-DTEST_ATLAS_XML_PATH="${PROJECT_SOURCE_DIR}/protocol/spec/atlas.xml")

wf_add_benchmark(benchmark/Objects_asMessage.cpp)
wf_add_benchmark(benchmark/Objects3_Move.cpp)
wf_add_benchmark(benchmark/Call_Move.cpp)
wf_add_benchmark(benchmark/Message_Move.cpp)
wf_add_benchmark(benchmark/Static_Move.cpp)
wf_add_benchmark(benchmark/Objects_iterator.cpp)
wf_add_benchmark(benchmark/Codecs_Packed.cpp)
wf_add_benchmark(benchmark/Message_Element.cpp)
wf_add_benchmark(benchmark/Objects_setAttr.cpp)


# Doxygen support, exports a "docs" target.

find_package(Doxygen)

if (DOXYGEN_FOUND)

    set(DOXYGEN_INPUT Doxyfile)
    set(DOXYGEN_OUTPUT doc)

    add_custom_command(
            OUTPUT ${DOXYGEN_OUTPUT}
            COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
            COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
            COMMAND ${CMAKE_COMMAND} -E echo "Done."
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
            DEPENDS ${DOXYGEN_INPUT}
    )

    add_custom_target(docs DEPENDS ${DOXYGEN_OUTPUT})


endif (DOXYGEN_FOUND)

add_custom_command(
        OUTPUT ChangeLog
        COMMAND ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR} 8bd480b053190ffde2afe33af66f484953036f5a
)
add_custom_target(changelog DEPENDS ChangeLog)


# Packaging (for source tarballs

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${DESCRIPTION})
set(CPACK_PACKAGE_VENDOR "Worldforge")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR "${ATLAS_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${ATLAS_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${ATLAS_VERSION_PATCH}")
#set(CPACK_INSTALL_SCRIPT "sh ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CPACK_PACKAGE_INSTALL_DIRECTORY} 8bd480b053190ffde2afe33af66f484953036f5a")

set(CPACK_SOURCE_GENERATOR TBZ2 ZIP)

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}" CACHE INTERNAL "tarball basename")

set(CPACK_SOURCE_IGNORE_FILES
        # no hidden files
        "/\\\\..+$"
        "~$"
        )

include(CPack)

=== Atlas-Python/atlas/util/Makefile ===
all: texturemodule.so 

texturemodule.so: texturemodule.o
	gcc -shared -lgif -L/usr/X11R6/lib -lX11 -o texturemodule.so texturemodule.o

texturemodule.o: texturemodule.c
	gcc -O2 -fPIC -I/usr/include/python2.2/ -c texturemodule.c

=== Atlas/Bindings/Python/Makefile ===
all: ccAtlasObjectmodule.so ccAtlasNetcmodule.so

wrapperNet.cpp: wrapperNet.i Socket.i TCPSocket.i Codec.i \
		Protocol.i XMLProtocol.i PackedProtocol.i wrapperClient.h
	swig -python -shadow -c++ -o wrapperNet.cpp wrapperNet.i

wrapperClient.o: wrapperClient.cpp wrapperClient.h
	g++ -g -Wall -c -o wrapperClient.o wrapperClient.cpp -I/usr/include/python1.5

ccAtlasNetcmodule.so: wrapperNet.cpp wrapperObject.h wrapperClient.o
	g++ -g -Wall --shared -o ccAtlasNetcmodule.so wrapperClient.o wrapperNet.cpp -I/usr/include/python1.5 -lAtlasObject -lAtlasNet

ccAtlasObjectmodule.so: wrapperObject.cpp
	g++ -g -Wall --shared -o ccAtlasObjectmodule.so wrapperObject.cpp -I/usr/include/python1.5 -lAtlasObject -lAtlasNet
